// AppDlg.h : header file
//

#pragma once

#include "graph.h"
#include "afxwin.h"
#include "fourier.h"

// CAppDlg dialog
class CAppDlg : public CDialog
{
// Construction
public:
	CAppDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_PHD_FFT_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

	//

public:
	CGraph m_Graph;
	CString m_strExpression;
	int m_nSamples;
	CScrollBar m_wndScroll;
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	UINT_PTR m_nTimer;
	UINT_PTR m_nRecomputeTimer;
	UINT_PTR m_nScanTimer;
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	CFourier m_fft;
	CGraph m_gFourier;
	CString m_strBandwidth;
	CString m_strSamples;
	int m_nWindowLength;
	afx_msg void OnWindowSizeChange();
	void GenerateSource();
	void GenerateWindow();
	void GenerateResult();
	void ComputeFourier();

	afx_msg void OnBnClickedButton2();
	void DoScan();

	CGraph m_gSpectrum;
	CComboBox m_comWindow;
	afx_msg void OnWindowFuncChange();
	CString m_strWindowLenSamples;
	CComboBox m_comSpectrumCalc;
};
